//	{GotLag?}'s Utility Library v2.6
//	Code Copyright (c) 2001,2002 Robert "{GotLag?}" McAfee
//
//	http://www.rmca.net	***	gotlag@rmca.net
//
//	If you use this in whole or in part, please give me some credit, just put a comment your script.
//
//	This library is recommended for computers with at least a 200Mhz Processor and 32 MB of RAM.
//	This is mainly due to the old GrabChars, it might not be a problem now, but still be warned.

//	VERSION NOTES
//	- Found old "lost" and forgotten code that was under a different filename (opps!)
//	- Added Dot Operators, ProcessCommand, DynamicFormation
//	- Added ClientPing and ServerPing
 
//	CONTENTS:
//	- IsNumeric
//	- abs
//	- FindString 1.5
//	- ReplaceString
//	- sprintf
//	- strcmp
//	- stricmp
//	- strtok
//	- ExportEx 1.1
//	- GrabChars 3.0
//	- FastGrabChars
//	- letterCheck 2.0
//	- Hex <-> Integer conversion array
//	- IntToHex
//	- HexToInt
//	- HexToChar
//	- CharToHex
//	- IntToChar
//	- CharToInt
//	- ProcessCommand
//	- Dot Operators
//	- DynamicFormation
//	- ClientPing
//	- ServerPing

//-------------------------------------------------------
// IsNumeric
//	- Determines if variable is string or number.
//	- Remember that "11" == 11 so it is a number.
//	- Has "issues" that need to be addressed, like E, e, and 0.
//
//	RETURNS:
//	- Variable is number: True
//	- Variable is string: False
//-------------------------------------------------------

function IsNumeric(%v){if(!(%v<="\xFF"&&%v==0)){return True;}else{return False;}}

//-------------------------------------------------------
// abs
//	- Returns absolute value.
//-------------------------------------------------------
function abs(%n)
{
//echo("abs( <number> );");
if(%n<0)%n=%n*-1;
}

//-------------------------------------------------------
// FindString 1.5
//	- Finds position of substring starting at a given point.
//	- Starting point is optional.
//
//	RETURNS:
//	- Negative One if substring can't be found.
//	- Position of substring if it is found.
//-------------------------------------------------------

function FindString(%str,%c,%start)
{
//echo("FindString( <string>, <sub string>, <start position> );");
if(%start=="")%start=0;
%str=convertspaces(%str);
%c=convertspaces(%c);
for(%x=%start;%x<strlen(%str);%x++)
{
if(strcat(strAlign(%x,left,%str),%c)==strAlign(%x+strlen(%c),left,%str))
{
return %x;
}
}
return -1;
}

//-------------------------------------------------------
// ReplaceString
//	- Replaces all matching strings with another.
//	- Requires FindString(), GrabChars(), letterCheck(), FastGrabChars()
//
//	RETURNS:
//	- The resulting string.
//-------------------------------------------------------

function ReplaceString(%str,%s,%r)
{
//echo("ReplaceString( <string>, <replace this>, <with this> );");

while( ( (%i=FindString(%str,%s,%i)) != -1))
{
%str=strcat(strcat(FastGrabChars(%str,l,%i),%r),FastGrabChars(%str,r,strlen(%str)-%i-strlen(%r)));
}
return %str;
}

//-------------------------------------------------------
// sprintf
//	- Turns a format string into something useful.
//	- Requires FindString(), GrabChars(), FastGrabChars()
//
//	RETURNS:
//	- The resulting string.
//-------------------------------------------------------

function sprintf(%str,%var0,%var1,%var2,%var3,%var4,%var5,%var6,%var7,%var8,%var9,%var10,%var11,%var12,%var13,%var14,%var15)
{
//echo("sprintf( <format string>, [variables - 15 max] );");
%v=0;
while( ( (%i=FindString(%str,"%v",%i)) != -1) || (%v > 15) )
{
eval("%str=strcat(strcat(FastGrabChars(%str,l,%i),%var"@%v@"),FastGrabChars(%str,r,strlen(%str)-%i-2));");
%v++;
}

return %str;
}

//-------------------------------------------------------
// strcmp
//	- Compares two strings, case sensitive.
//
//	RETURNS:
// -1 - String A < String B
//	0 - Strings Equal
//	1 - String A > String B
//-------------------------------------------------------
function strcmp(%a,%b)
{
//echo("strcmp( <string1>, <string2> );");

if(%a==%b)return 0;
else
if(%a<%b)return -1;
else
if(%a>%b)return 1;
}

//-------------------------------------------------------
// stricmp
//	- Compares two strings, case insensitive.
//	- Requires GrabChars()
//
//	RETURNS:
// -1 - String A < String B
//	0 - Strings Equal
//	1 - String A > String B
//-------------------------------------------------------
function stricmp(%a,%b)
{
//echo("strcmp( <string1>, <string2> );");

%a=FastGrabChars(%a,l,strlen(%a),0,upper);
%b=FastGrabChars(%b,l,strlen(%b),0,upper);
if(%a==%b)return 0;
else
if(%a<%b)return -1;
else
if(%a>%b)return 1;
}

//-------------------------------------------------------
// strtok
//	- Grabs tokens from a string.
//	- Tokens are placed into global array.
//	- Optional starting position.
//	- Requires FindString(), GrabChars(), FastGrabChars()
//
//	RETURNS:
//	- Number of tokens collected.
//-------------------------------------------------------
function strtok(%str,%tok,%array_name,%start)
{
//echo("strtok( <string>, <token>, <array name>, <start position> );");
if(%start=="")%start=0;
%t=-1;

while( ((%i=FindString(%str,%tok,%start)) != -1) )
{
%t++;
eval("$"@%array_name@%t@"=FastGrabChars(%str,c,abs(%i-%start),%start);");
%start=%i+1;
}

%t++;
eval("$"@%array_name@%t@"=FastGrabChars(%str,c,abs((%start)-strlen(%str)),%start);");

return %t+1;
}

//-------------------------------------------------------
// ExportEx 1.1
//	- Exports a variable using hex.
//	- Used as a workaround to the export() bug (it exports invalid hex).
//	- For exporting something where you need all 255 ANSI characters exported properly.
//	- Basically a stipped down reverse engineered GrabChars. :)
//
//	USAGE:
//	- ExportEx( <variable>, <file>, <append> );
//	- Example: ExportEx("$TEST","myfile.cs",append);
//
//	RETURNS:
//	- Nothing
//-------------------------------------------------------
function ExportEx(%variable,%file,%append)
{
eval("%content="@%variable@";");
%len=strlen(%content);
%write="filewrite(\""@%file@"\","@%append@",\""@%variable@"=\\\"";
for(%i=0;%i<%len;%i++)
{
%base = strAlign(%i, l, %content);
%last = strAlign(%i+1, l, %content);
for(%x=2;%x<=15;%x++)
{
for(%y=0;%y<=15;%y++)
{
eval("%tmp=%base@\"\\x"@$HEX[%x]@$HEX[%y]@"\";");
if(%tmp == %last)
{
eval("%tmp=\"\\\\\\\\x"@$HEX[%x]@$HEX[%y]@"\";");
%write=%write@%tmp;
}
}
}
}
eval(%write@"\\\";\");");
}

//-------------------------------------------------------
// GrabChars 3.0
//	- Grabs characters from the left, center, or right of a string.
//	- Supports character case conversion.
//	- Requires letterCheck()
//
//	FAST PROCESSING:
//	- Processes a space (' ') to a '~', which includes every keyboard key.
//	- Skips 128 uncommon characters.
//
//	NON-FAST PROCESSING:
//	- Processes a space to a 'y' with two dots over it.
//	- Processes all 223 valid characters.
//
//	INVALID CHARACTERS:
//	- Anything below the ANSI space (' ') will screw up GrabChars.
//	- This is anything 0 to 31, hex range 0x00 to 0x1F.
//	- These are often used to "cheat" in SS, so they are skipped.
//
//	USAGE:
//	- GrabChars( <str>, <dir: l/c/r>, <num>, <start>, <fast: 1 or 0>, <case: lower/upper> );
//
//	RETURNS:
//	- Resulting string.
//-------------------------------------------------------

function GrabChars(%str,%dir,%num,%start,%fast,%case)
{
//echo("GrabChars( <string>, <direction: l/c/r>, <number to grab>, <start position>, <fast: 1 or 0>, <case: upper/lower> );");
if(%start=="") %start=0;
if(%fast==""||%fast==0) %fast=2;
%str=ConvertSpaces(%str);

if(%dir == c || %dir == "c")
%len=%start+%num;
else if(%dir == l || %dir == "l")
%len=%num;
else if(%dir == r || %dir == "r")
{
%len = strlen(%str);
%start=%len-%num;
}

for(%x=%start+1;%x<=%len;%x++)
{
%letter[%x] = letterCheck(strAlign(%x, l, %str),%fast,%case);
if(%letter[%x] == "_") %letter[%x]=" ";
}

if(%dir == l || %dir == "l")
{
for(%x=%start;%x<=%len;%x++)
{
%end=strcat(%end,%letter[%x]);
}
}
else if(%dir == r || %dir == "r")
{
for(%x=%len;%x>=%start;%x--)
{
%end=strcat(%letter[%x], %end);
}
}
else if(%dir == c || %dir == "c")
{
for(%x=%start;%x<=%len;%x++)
{
%end=strcat(%end,%letter[%x]);
}
}
return(%end);
}

//-------------------------------------------------------
// FastGrabChars
//	- Always using fast option (Read GrabChars comment).
//
//	RETURNS:
//	- Resulting string.
//-------------------------------------------------------

function FastGrabChars(%str,%dir,%num,%start,%case)
{
//echo("FastGrabChars( <string>, <direction: l/c/r>, <number to grab>, <start position>, <case: upper/lower> );");
return GrabChars(%str,%dir,%num,%start,1,%case);
}

//-------------------------------------------------------
// letterCheck v2.0
//	- Thanks to Dull for his original function.
//	- Contains core processing of GrabChars.
//
//	RETURNS:
//	- Character matching end character of string passed.
//-------------------------------------------------------

function letterCheck(%str,%fast,%case)
{
%last = strAlign((strlen(%str) - 1), l, %str);

if(%fast==1)
%max_x=7;
else
%max_x=15;

for(%x=2;%x<=%max_x;%x++)
{
for(%y=0;%y<=15;%y++)
{
eval("%tmp3=\"\\x"@strcat($HEX[%x],$HEX[%y])@"\";");

if( ( %str == strcat(%last, "e") ) && (%tmp3 == "+") )
%tmp3="e";
else
if( ( %str == strcat(%last, "E") ) && (%tmp3 == "+") )
%tmp3="E";

if( %str == strcat(%last, %tmp3 ) )
{
if( ( %case=="lower" || %case==lower ) && (%tmp3>="A" && %tmp3<="Z") )
eval("%tmp3=\"\\x"@strcat(%x+2,%tmp2)@"\";");
else
if( ( %case=="upper" || %case==upper ) && (%tmp3>="a" && %tmp3<="z") )
eval("%tmp3=\"\\x"@strcat(%x-2,%tmp2)@"\";");
return %tmp3;
}
}
}
}

//-------------------------------------------------------
// Hex <-> Integer conversion arrays
//
//	- All GrabChars functions need this.
//	- All Hex, Char, and Int conversion functions need this.
//-------------------------------------------------------

$HEX0=0;
$HEX1=1;
$HEX2=2;
$HEX3=3;
$HEX4=4;
$HEX5=5;
$HEX6=6;
$HEX7=7;
$HEX8=8;
$HEX9=9;
$HEX10=A;
$HEX11=B;
$HEX12=C;
$HEX13=D;
$HEX14=E;
$HEX15=F;
$HEX[A]=10;
$HEX[B]=11;
$HEX[C]=12;
$HEX[D]=13;
$HEX[E]=14;
$HEX[F]=15;

//-------------------------------------------------------
// IntToHex
//
//	- Converts integer <= 255 to hex.
//
//	RETURNS:
//	- Hex string.
//-------------------------------------------------------

function IntToHex(%n)
{
if(%n > 255 || %n < 0)
{
echo("Must be a positive number less than or equal to 255.");
return;
}
%first = %n / 16;
if(%n < 160)
%first = stralign(1,left,%first);
else
%first = stralign(2,left,%first);
return $hex[%first] @ $hex[(%n % 16)];
}

//-------------------------------------------------------
// HexToInt
//
//	- Converts hex string <= 0xFF to integer.
//	- Only accepts the hex in the form "FF".
//
//	RETURNS:
//	- Integer value of the hex.
//-------------------------------------------------------

function HexToInt(%h)
{
if(%h > "FF")
{
echo("Must be a hex string less than or equal to 0xFF.");
return;
}
%num=$HEX[stralign(1,left,%h)];
if(strlen(%h) > 1)
%num=(%num*16)+$HEX[FastGrabChars(%h,r,1)];
return %num;
}

//-------------------------------------------------------
// HexToChar
//	- Converts hex string to corresponding ANSI letter.
//
//	RETURNS:
//	- Resulting character.
//-------------------------------------------------------

function HexToChar(%h)
{
if(%h > "FF")
{
echo("Must be a hex string less than or equal to 0xFF.");
return;
}
eval("return \"\\x"@%h@"\";");
}

//-------------------------------------------------------
// CharToHex
//	- Converts ANSI letter to corresponding hex string.
//	- Requires IntToHex()
//
//	RETURNS:
//	- Hex string of character.
//-------------------------------------------------------

function CharToHex(%c)
{
if(strlen(%c)>1)
{
echo("Can only be used for single character.");
return;
}
for(%i=32;%i<=255;%i++)
{
eval("%tmp=\"\\x"@IntToHex(%i)@"\";");
if(%c == %tmp)return IntToHex(%i);
}
}

//-------------------------------------------------------
// IntToChar
//	- Converts ANSI value to corresponding character.
//	- Requires IntToHex()
//
//	RETURNS:
//	- Character corresponding to ANSI value.
//-------------------------------------------------------

function IntToChar(%n)
{
if(%n > 255)
{
echo("Must be a number less than or equal to 255.");
return;
}
eval("return \"\\x"@IntToHex(%n)@"\";");
}

//-------------------------------------------------------
// CharToInt
//	- Converts character to corresponding ANSI value.
//	- Requires IntToHex()
//
//	RETURNS:
//	- ANSI value corresponding to character.
//-------------------------------------------------------

function CharToInt(%c)
{
if(strlen(%c)>1)
{
echo("Can only be used for single character.");
return;
}
for(%i=32;%i<=255;%i++)
{
eval("%tmp=\"\\x"@IntToHex(%i)@"\";");
if(%c == %tmp)return %i;
}
}

//-------------------------------------------------------
// ProcessCommand
//	- Turns simple text into a function call.
//
//	USAGE:
//	- ProcessCommand("echo moo"); == echo(moo);
//	- ProcessCommand("order $MyAI attack 2049"); == order($MyAI,attack,2049);
//
//	RETURNS:
//	- Return value of function called, or True/False.
//-------------------------------------------------------
function ProcessCommand(%cmd)
{
%cnt = strtok(%cmd," ","cmd_tmp");
if(%cnt==0) return -1;
%cnt--;
%tmp="return "@$cmd_tmp0@"(";

function abs(%n){if(%n<0)%n=%n*-1;}

for(%i=1;%i<=%cnt;%i++)
{
%tmp=strcat(%tmp,$cmd_tmp[%i]);
if(abs(%cnt-%i)!=0)%tmp=%tmp@",";
}

eval(%tmp@");");
}

//-------------------------------------------------------
// Dot Op functions
//	- Functions executed via variable names.
//
//	EXAMPLE:
//	$x = newObject("TEST",Herc,1);
//	echo($x.getName());
//	ECHO: "TEST"
//
//	FUNCTION:			RETURNS:
//	- GetName()			Name of object.
//	- SetName(<new name>)		None.
//	- GetParent()			Parent of the object or zero if object is root object.
//	- GetPosition()			None.
//
//	- Add(<object to be added>)	None.
//	- Remove(<object in container>)	Negative one if object is not in container, otherwise one.
//	- GetNextObject(<object>)	Object ID, or zero if none found.
//	- GetObjectCount()		Count of objects in container, or zero if none.
//	- IndexObjects()		None.
//	- GetObject(<index>)		Object ID, or zero if none found.
//	- GetRandomObject()		Object ID of object in the container, or zero if no objects.
//
//	NOTE:
//	- GetObject() calls IndexObjects() every time.
//	- It is to ensure the indexes are correct if you add or remove an object.
//-------------------------------------------------------

//All Objects
function dot_op_GetName(%this){return GetObjectName(%this);}
function dot_op_SetName(%this,%name){renameObject(%this,%name);}
function dot_op_GetParent(%this){return GetGroup(%this);}
function dot_op_GetPosition(%this){%this.posx=getPosition(%this,x);%this.posy=getPosition(%this,y);%this.posz=getPosition(%this,z);}
//For Containers
function dot_op_Add(%this,%obj){addtoset(%this,%obj);}
function dot_op_Remove(%this,%obj){%tmp=%obj;while(%tmp=GetNextObject(%this,%tmp)){if(%tmp==%obj){deleteobject(%tmp);return 1;}}return -1;}
function dot_op_GetNextObject(%this,%obj_or_index){return GetNextObject(%this,%obj_or_index);}
function dot_op_GetObjectCount(%this){%tmp=%c=0;while(%tmp=GetNextObject(%this,%tmp)){%c++;}return %c;}
function dot_op_IndexObjects(%this){%tmp=%c=0;while(%tmp=GetNextObject(%this,%tmp)){eval("%this.obj"@%c@"="@%tmp@";");%c++;}}
function dot_op_GetObject(%this,%index){%this.IndexObjects();eval("return %this.obj"@%index@";");}
function GLRandomInt(%lowerbound,%upperbound){return floor(RandomInt(%lowerbound*100,%upperbound*100)/100);}
function dot_op_GetRandomObject(%this){return %this.GetObject(GLRandomInt(0,%this.GetObjectCount()));}

//-------------------------------------------------------
// DynamicFormation
//	- Creates a new AI formation based on the current positions of the AI.
//
//	USAGE:
//	- Place your AI where you want them.
//	- DynamixFormation(<formation name>, <leader ai>, <follower ai>, <follower ai>, ...);
//-------------------------------------------------------

function DynamicFormation(%name,%ai0,%ai1,%ai2,%ai3,%ai4,%ai5,%ai6,%ai7,%ai8,%ai9)
{
if(%name == ""){echo("No name!");return;}
else
if(%ai0 == ""){echo("No leader!");return;}

function dist(%a,%b){return %b-%a;}

%ai0.GetPosition();

%tmp="newFormation("@%name@",0,0,0";

for(%i=1;%i<10;%i++)
{
if(%ai[%i] != "")
{
%ai[%i].GetPosition();
%tmp=%tmp@","@(dist(%ai0.posx,%ai[%i].posx))@","@(dist(%ai0.posy,%ai[%i].posy))@",0";
}
}

%tmp=%tmp@");";
eval(%tmp);
echo(%tmp);
}

//-------------------------------------------------------
// ClientPing
//	- Pings any server from client.
//	- Displays estimated ping in message box.
//-------------------------------------------------------

function ClientPing()
{
function remoteServerReply()
{
LocalMessageBox("Your estimated ping is: "@floor((getSimTime()-$client::PingStart)*1000)@"ms");
}

$client::PingStart = getSimTime();

remoteeval(2048,"eval","ServerReply");
}

//-------------------------------------------------------
// ServerPing
//	- Pings all clients and tells them there ping.
//	- Not extremely useful in this format but you can see how it works.
//-------------------------------------------------------

function ServerPing()
{
function remoteClientReply(%p)
{
say(%p,%p,"Your estimated ping is: "@floor((getSimTime()-%p.PingStart)*1000)@"ms");
}

%c=playermanager::getPlayercount();
for(%i=0;%i<%c;%i++)
{
%p=playermanager::getplayernum(%i);
%p.PingStart=getSimTime();
remoteeval(%p,"eval","ClientReply");
}
}